"Main interface for transfer service type defs"
from __future__ import annotations

from datetime import datetime
import sys
from typing import List

if sys.version_info >= (3, 8):
    from typing import Literal
else:
    from typing_extensions import Literal
if sys.version_info >= (3, 8):
    from typing import TypedDict
else:
    from typing_extensions import TypedDict


ClientCreateServerEndpointDetailsTypeDef = TypedDict(
    "ClientCreateServerEndpointDetailsTypeDef", {"VpcEndpointId": str}, total=False
)

ClientCreateServerIdentityProviderDetailsTypeDef = TypedDict(
    "ClientCreateServerIdentityProviderDetailsTypeDef",
    {"Url": str, "InvocationRole": str},
    total=False,
)

ClientCreateServerResponseTypeDef = TypedDict(
    "ClientCreateServerResponseTypeDef", {"ServerId": str}, total=False
)

_RequiredClientCreateServerTagsTypeDef = TypedDict(
    "_RequiredClientCreateServerTagsTypeDef", {"Key": str}
)
_OptionalClientCreateServerTagsTypeDef = TypedDict(
    "_OptionalClientCreateServerTagsTypeDef", {"Value": str}, total=False
)


class ClientCreateServerTagsTypeDef(
    _RequiredClientCreateServerTagsTypeDef, _OptionalClientCreateServerTagsTypeDef
):
    pass


ClientCreateUserHomeDirectoryMappingsTypeDef = TypedDict(
    "ClientCreateUserHomeDirectoryMappingsTypeDef", {"Entry": str, "Target": str}, total=False
)

ClientCreateUserResponseTypeDef = TypedDict(
    "ClientCreateUserResponseTypeDef", {"ServerId": str, "UserName": str}, total=False
)

_RequiredClientCreateUserTagsTypeDef = TypedDict(
    "_RequiredClientCreateUserTagsTypeDef", {"Key": str}
)
_OptionalClientCreateUserTagsTypeDef = TypedDict(
    "_OptionalClientCreateUserTagsTypeDef", {"Value": str}, total=False
)


class ClientCreateUserTagsTypeDef(
    _RequiredClientCreateUserTagsTypeDef, _OptionalClientCreateUserTagsTypeDef
):
    pass


ClientDescribeServerResponseServerEndpointDetailsTypeDef = TypedDict(
    "ClientDescribeServerResponseServerEndpointDetailsTypeDef", {"VpcEndpointId": str}, total=False
)

ClientDescribeServerResponseServerIdentityProviderDetailsTypeDef = TypedDict(
    "ClientDescribeServerResponseServerIdentityProviderDetailsTypeDef",
    {"Url": str, "InvocationRole": str},
    total=False,
)

ClientDescribeServerResponseServerTagsTypeDef = TypedDict(
    "ClientDescribeServerResponseServerTagsTypeDef", {"Key": str, "Value": str}, total=False
)

ClientDescribeServerResponseServerTypeDef = TypedDict(
    "ClientDescribeServerResponseServerTypeDef",
    {
        "Arn": str,
        "EndpointDetails": ClientDescribeServerResponseServerEndpointDetailsTypeDef,
        "EndpointType": Literal["PUBLIC", "VPC_ENDPOINT"],
        "HostKeyFingerprint": str,
        "IdentityProviderDetails": ClientDescribeServerResponseServerIdentityProviderDetailsTypeDef,
        "IdentityProviderType": Literal["SERVICE_MANAGED", "API_GATEWAY"],
        "LoggingRole": str,
        "ServerId": str,
        "State": Literal[
            "OFFLINE", "ONLINE", "STARTING", "STOPPING", "START_FAILED", "STOP_FAILED"
        ],
        "Tags": List[ClientDescribeServerResponseServerTagsTypeDef],
        "UserCount": int,
    },
    total=False,
)

ClientDescribeServerResponseTypeDef = TypedDict(
    "ClientDescribeServerResponseTypeDef",
    {"Server": ClientDescribeServerResponseServerTypeDef},
    total=False,
)

ClientDescribeUserResponseUserHomeDirectoryMappingsTypeDef = TypedDict(
    "ClientDescribeUserResponseUserHomeDirectoryMappingsTypeDef",
    {"Entry": str, "Target": str},
    total=False,
)

ClientDescribeUserResponseUserSshPublicKeysTypeDef = TypedDict(
    "ClientDescribeUserResponseUserSshPublicKeysTypeDef",
    {"DateImported": datetime, "SshPublicKeyBody": str, "SshPublicKeyId": str},
    total=False,
)

ClientDescribeUserResponseUserTagsTypeDef = TypedDict(
    "ClientDescribeUserResponseUserTagsTypeDef", {"Key": str, "Value": str}, total=False
)

ClientDescribeUserResponseUserTypeDef = TypedDict(
    "ClientDescribeUserResponseUserTypeDef",
    {
        "Arn": str,
        "HomeDirectory": str,
        "HomeDirectoryMappings": List[ClientDescribeUserResponseUserHomeDirectoryMappingsTypeDef],
        "HomeDirectoryType": Literal["PATH", "LOGICAL"],
        "Policy": str,
        "Role": str,
        "SshPublicKeys": List[ClientDescribeUserResponseUserSshPublicKeysTypeDef],
        "Tags": List[ClientDescribeUserResponseUserTagsTypeDef],
        "UserName": str,
    },
    total=False,
)

ClientDescribeUserResponseTypeDef = TypedDict(
    "ClientDescribeUserResponseTypeDef",
    {"ServerId": str, "User": ClientDescribeUserResponseUserTypeDef},
    total=False,
)

ClientImportSshPublicKeyResponseTypeDef = TypedDict(
    "ClientImportSshPublicKeyResponseTypeDef",
    {"ServerId": str, "SshPublicKeyId": str, "UserName": str},
    total=False,
)

ClientListServersResponseServersTypeDef = TypedDict(
    "ClientListServersResponseServersTypeDef",
    {
        "Arn": str,
        "IdentityProviderType": Literal["SERVICE_MANAGED", "API_GATEWAY"],
        "EndpointType": Literal["PUBLIC", "VPC_ENDPOINT"],
        "LoggingRole": str,
        "ServerId": str,
        "State": Literal[
            "OFFLINE", "ONLINE", "STARTING", "STOPPING", "START_FAILED", "STOP_FAILED"
        ],
        "UserCount": int,
    },
    total=False,
)

ClientListServersResponseTypeDef = TypedDict(
    "ClientListServersResponseTypeDef",
    {"NextToken": str, "Servers": List[ClientListServersResponseServersTypeDef]},
    total=False,
)

ClientListTagsForResourceResponseTagsTypeDef = TypedDict(
    "ClientListTagsForResourceResponseTagsTypeDef", {"Key": str, "Value": str}, total=False
)

ClientListTagsForResourceResponseTypeDef = TypedDict(
    "ClientListTagsForResourceResponseTypeDef",
    {"Arn": str, "NextToken": str, "Tags": List[ClientListTagsForResourceResponseTagsTypeDef]},
    total=False,
)

ClientListUsersResponseUsersTypeDef = TypedDict(
    "ClientListUsersResponseUsersTypeDef",
    {
        "Arn": str,
        "HomeDirectory": str,
        "HomeDirectoryType": Literal["PATH", "LOGICAL"],
        "Role": str,
        "SshPublicKeyCount": int,
        "UserName": str,
    },
    total=False,
)

ClientListUsersResponseTypeDef = TypedDict(
    "ClientListUsersResponseTypeDef",
    {"NextToken": str, "ServerId": str, "Users": List[ClientListUsersResponseUsersTypeDef]},
    total=False,
)

_RequiredClientTagResourceTagsTypeDef = TypedDict(
    "_RequiredClientTagResourceTagsTypeDef", {"Key": str}
)
_OptionalClientTagResourceTagsTypeDef = TypedDict(
    "_OptionalClientTagResourceTagsTypeDef", {"Value": str}, total=False
)


class ClientTagResourceTagsTypeDef(
    _RequiredClientTagResourceTagsTypeDef, _OptionalClientTagResourceTagsTypeDef
):
    pass


ClientTestIdentityProviderResponseTypeDef = TypedDict(
    "ClientTestIdentityProviderResponseTypeDef",
    {"Response": str, "StatusCode": int, "Message": str, "Url": str},
    total=False,
)

ClientUpdateServerEndpointDetailsTypeDef = TypedDict(
    "ClientUpdateServerEndpointDetailsTypeDef", {"VpcEndpointId": str}, total=False
)

ClientUpdateServerIdentityProviderDetailsTypeDef = TypedDict(
    "ClientUpdateServerIdentityProviderDetailsTypeDef",
    {"Url": str, "InvocationRole": str},
    total=False,
)

ClientUpdateServerResponseTypeDef = TypedDict(
    "ClientUpdateServerResponseTypeDef", {"ServerId": str}, total=False
)

ClientUpdateUserHomeDirectoryMappingsTypeDef = TypedDict(
    "ClientUpdateUserHomeDirectoryMappingsTypeDef", {"Entry": str, "Target": str}, total=False
)

ClientUpdateUserResponseTypeDef = TypedDict(
    "ClientUpdateUserResponseTypeDef", {"ServerId": str, "UserName": str}, total=False
)

ListServersPaginatePaginationConfigTypeDef = TypedDict(
    "ListServersPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)

ListServersPaginateResponseServersTypeDef = TypedDict(
    "ListServersPaginateResponseServersTypeDef",
    {
        "Arn": str,
        "IdentityProviderType": Literal["SERVICE_MANAGED", "API_GATEWAY"],
        "EndpointType": Literal["PUBLIC", "VPC_ENDPOINT"],
        "LoggingRole": str,
        "ServerId": str,
        "State": Literal[
            "OFFLINE", "ONLINE", "STARTING", "STOPPING", "START_FAILED", "STOP_FAILED"
        ],
        "UserCount": int,
    },
    total=False,
)

ListServersPaginateResponseTypeDef = TypedDict(
    "ListServersPaginateResponseTypeDef",
    {"Servers": List[ListServersPaginateResponseServersTypeDef]},
    total=False,
)
